commit c5088213a245e2bc1eaafa27cf65ff117f86f21c
Author: freddy77 <freddy77>
Date:   Sat Apr 10 14:22:09 2010 +0000

    make execution faster if log disabled (patch from Steve Brown)

diff --git a/ChangeLog b/ChangeLog
index 5b26ba6..1ca80b8 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Sat Apr 10 16:21:49 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/tds/log.c:
+	- make execution faster if log disabled (patch from Steve Brown)
+
 Thu Apr  8 11:02:24 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/apps/bsqldb.c: remove some conversion warnings
 
@@ -2388,4 +2392,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3007 2010/04/08 09:02:55 freddy77 Exp $
+$Id: ChangeLog,v 1.3008 2010/04/10 14:22:09 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index b81474e..08580ee 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -21,7 +21,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.333 2010/04/08 08:19:16 freddy77 Exp $ */
+/* $Id: tds.h,v 1.334 2010/04/10 14:22:09 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1581,12 +1581,15 @@ int tdsdump_open(const char *filename);
 void tdsdump_close(void);
 void tdsdump_dump_buf(const char* file, unsigned int level_line, const char *msg, const void *buf, size_t length);
 void tdsdump_col(const TDSCOLUMN *col);
+#undef tdsdump_log
 void tdsdump_log(const char* file, unsigned int level_line, const char *fmt, ...)
-
 #if defined(__GNUC__) && __GNUC__ >= 2
 	__attribute__ ((__format__ (__printf__, 3, 4)))
 #endif
 ;
+#define tdsdump_log if (tds_write_dump) tdsdump_log
+
+extern int tds_write_dump;
 extern int tds_debug_flags;
 extern int tds_g_append_mode;
 
diff --git a/src/tds/log.c b/src/tds/log.c
index 335bf59..3d51bcd 100644
--- a/src/tds/log.c
+++ b/src/tds/log.c
@@ -66,13 +66,13 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: log.c,v 1.17 2010/01/28 13:31:51 freddy77 Exp $");
+TDS_RCSID(var, "$Id: log.c,v 1.18 2010/04/10 14:22:09 freddy77 Exp $");
 
 /* for now all messages go to the log */
 int tds_debug_flags = TDS_DBGFLAG_ALL | TDS_DBGFLAG_SOURCE;
 int tds_g_append_mode = 0;
 static char *g_dump_filename = NULL;
-static int write_dump = 0;	/* is TDS stream debug log turned on? */
+int tds_write_dump = 0;	/* is TDS stream debug log turned on? */
 static FILE *g_dumpfile = NULL;	/* file pointer for dump log          */
 static TDS_MUTEX_DEFINE(g_dump_mutex);
 
@@ -93,7 +93,7 @@ void
 tdsdump_off(void)
 {
 	TDS_MUTEX_LOCK(&g_dump_mutex);
-	write_dump = 0;
+	tds_write_dump = 0;
 	TDS_MUTEX_UNLOCK(&g_dump_mutex);
 }				/* tdsdump_off()  */
 
@@ -105,7 +105,7 @@ void
 tdsdump_on(void)
 {
 	TDS_MUTEX_LOCK(&g_dump_mutex);
-	write_dump = 1;
+	tds_write_dump = 1;
 	TDS_MUTEX_UNLOCK(&g_dump_mutex);
 }
 
@@ -166,7 +166,7 @@ tdsdump_open(const char *filename)
 	}
 
 	if (result)
-		write_dump = 1;
+		tds_write_dump = 1;
 	TDS_MUTEX_UNLOCK(&g_dump_mutex);
 
 	if (result) {
@@ -221,7 +221,7 @@ void
 tdsdump_close(void)
 {
 	TDS_MUTEX_LOCK(&g_dump_mutex);
-	write_dump = 0;
+	tds_write_dump = 0;
 	if (g_dumpfile != NULL && g_dumpfile != stdout && g_dumpfile != stderr)
 		fclose(g_dumpfile);
 	g_dumpfile = NULL;
@@ -287,7 +287,7 @@ tdsdump_dump_buf(const char* file, unsigned int level_line, const char *msg, con
 	char line_buf[BYTES_PER_LINE * 8 + 16], *p;
 	FILE *dumpfile;
 
-	if (((tds_debug_flags >> debug_lvl) & 1) == 0 || !write_dump)
+	if (((tds_debug_flags >> debug_lvl) & 1) == 0 || !tds_write_dump)
 		return;
 
 	if (!g_dumpfile && !g_dump_filename)
@@ -366,6 +366,7 @@ tdsdump_dump_buf(const char* file, unsigned int level_line, const char *msg, con
 }				/* tdsdump_dump_buf()  */
 
 
+#undef tdsdump_log
 /**
  * Write a message to the debug log.  
  * \param file name of the log file
@@ -380,7 +381,7 @@ tdsdump_log(const char* file, unsigned int level_line, const char *fmt, ...)
 	va_list ap;
 	FILE *dumpfile;
 
-	if (((tds_debug_flags >> debug_lvl) & 1) == 0 || !write_dump)
+	if (((tds_debug_flags >> debug_lvl) & 1) == 0 || !tds_write_dump)
 		return;
 
 	if (!g_dumpfile && !g_dump_filename)
@@ -419,6 +420,8 @@ tdsdump_log(const char* file, unsigned int level_line, const char *fmt, ...)
 #endif
 	TDS_MUTEX_UNLOCK(&g_dump_mutex);
 }				/* tdsdump_log()  */
+#define tdsdump_log if (tds_write_dump) tdsdump_log
+
 
 /**
  * Write a column value to the debug log.  

